File: 
Description:

Notes:
ToDo:
<'
define DBG_SO_BUG TRUE;
import matlab;
extend sn_matlab_complex_s {
	init() is also {
		r = new sn_matlab_double_s;
		i = new sn_matlab_double_s;
	};
};
extend matlab_mx_array_s {
		//===============================================================================
		//Method:	get_item 
		//Description:
		//	get one element out of a matrix.
		//	a pointer to the matrix was saved when get_var was called.
		//	an element is designated by its row,column indices.
		//	we start counting from the top left corner of the matrix.
		//	the first element is designated by row:col of 0:0.
		//	the total number of elements = rows * cols.
		//	the last elemt in the matrix can be retrieved by: get_item( rows-1, cols-1),
		//	i.e., if we have just one element in the matrix we'll have: get_item(0,0).
		//Type:
		//Parameters:
		//	ro	
		//		the row number. note that counting starts from 0, just like
		//		e lists.
		//	co
		//		the column number. counting starts from 0.
		//Returns:
		//	one matrix element encapsulated within a sn_matlab_complex_s.
		//Notes:
		//Created By: meir@verisity.com
		//ToDo:
		//===============================================================================
	get_item(ro : uint, co : uint ) : sn_matlab_complex_s is also {
		var ep : uint;
		var res : sn_matlab_complex_s = new;
		try {
			//check that ep != mx_ptr;
			check that ro < rows;
			check that co < cols;
			get_mx_item(ro, co, res);
			result = res;
		} else {
		};
	};
	get_item_as_uint64(ro : uint, co : uint ) : sn_matlab_complex_s is also {
		var ep : uint;
		var res : sn_matlab_complex_s = new;
		try {
			check that ep != mx_ptr;
			check that ro < rows;
			check that co < cols;
			get_mx_item_as_uint64(ro, co, res);
			result = res;
		} else {
		};
	};
#ifndef DYNAMIC {
	//for static linking...
	get_mx_item(ro : uint, co : uint, result: sn_matlab_complex_s) is C routine sn_matlab_get_mx_item ;
	get_mx_item_as_uint64(ro : uint, co : uint, result: sn_matlab_complex_s) is 
								C routine sn_matlab_get_mx_item ;
	free_mx_ptr() is C routine sn_matlab_free_mx;
} else {
	//for dynamic linking...
	get_mx_item(ro : uint, co: uint, result: sn_matlab_complex_s) is dynamic C routine ./snmb:sn_matlab_get_mx_item ;
	get_mx_item_as_uint64(ro:uint, co : uint, result: sn_matlab_complex_s) is 
								dynamic C routine ./snmb:sn_matlab_get_mx_item ;
	free_mx_ptr() is dynamic C routine ./snmb:sn_matlab_free_mx;
};
//#ifdef DBG_SO_BUG {
	//!mx_ptr	: uint(bits:64);	//a pointer to an external mxArray matlab struct
	!mx_ptr	: uint;	//a pointer to an external mxArray matlab struct (lower 32 bits)
	!mx_ptr_upper	: uint;	//a pointer to an external mxArray matlab struct (upper 32 bits)
//};
};
extend sn_matlab_var_s {
	init() is also {
		its_class = MB_INT32;
		is_complex = FALSE;
		mx_arr = new matlab_mx_array_s;
	};
	get_item(idx : uint ) : sn_matlab_complex_s is also {
		var res : sn_matlab_complex_s = new;
		try {
			var no_of_el : uint = r_data.size();
			if( is_double() or is_int64() ) {
				idx <<= 1;//adjust index if a double or int64
			};
			check that idx < no_of_el;
				//get the real part
			res.is_double = is_double();
			res.is_int64 = is_int64();
			res.is_complex = is_complex;
			res.r.is_double = res.is_double; 
			res.r.is_int64 = res.is_int64; 
			res.r.low = r_data[idx];
			if( is_double() or is_int64() ) {
				res.r.high = r_data[idx+1];
			};
			if( is_complex ) {
				//get the imaginary part
				res.i.is_double = res.is_double; 
				res.i.is_int64 = res.is_int64; 
				res.i.low = i_data[idx];
				if( is_double() or is_int64() ) {
					res.i.high = i_data[idx+1];
				};
			};
			result = res;
		} else {
		};
	};
};
extend matlab_ifc_s {
	!eng	: external_pointer;	//the pointer to the matlab environment.
	exec(statements : list of string) : matlab_rc_t is also { 
		var line : string;
		check that is_initialized();
		for each (line) in statements {
			dbg_out(dbg_flag, "matlab.exec(): execute cmd: ", line);		
			last_rc = do_matlab(line);
			dbg_out(dbg_flag, "matlab.exec(): cmd output=", last_msg);		
			check_result();
		};
		result = last_rc;//return the last result
	};	
	get_var(v : sn_matlab_var_s) : matlab_rc_t is also {
		try {
			check that is_initialized() ;
			check that is_valid_var(v);
			dbg_out(dbg_flag, "matlab.get_var(v): getting variable = '", v.name, "' from matlab workspace");
			result = matlab_get_var(v);
			mx_ptrs.add( v.mx_arr );	//add the resulted array to the list for later dealloc
			check_result();
				//set name if successful
			v.mx_arr.name = v.name;			
		} else {
			result = ERROR;
			last_rc = ERROR;
			return result;
		};
	};
	put_var(v : sn_matlab_var_s) : matlab_rc_t is also {
		try {
			check that is_initialized() ;
			check that is_valid_var(v);
			dbg_out(dbg_flag, "matlab.put_var(v): putting variable = '", v.name, "' to matlab workspace");
			result = matlab_put_var(v);
			check_result();
		} else {
			result = ERROR;
			last_rc = ERROR;
			return result;
		};
	};
		//check if last call was successful and print out any error messages
	check_result() is {
		if last_rc != SUCCESS {
			//print err msg 
			out("MATLAB: Error! ", last_msg);
		} else {
			dbg_out(dbg_flag, "matlab.check_result(): last matlab command result = SUCCESS");
		};
	};
		//initialize the matlab engine, i.e., establish a connection
		//and set the transfer area
	do_init() is {
		last_rc = matlab_init();
		if last_rc == SUCCESS {
			state = MATLAB_STATE_INIT;
		};
	};
	is_equal(sn_var : sn_matlab_var_s, mb_var : matlab_mx_array_s) : bool is also {
		result = FALSE;
		try {
				//first check class_id
			check that sn_var.its_class == mb_var.its_class;
				//check same length 
			var uint_sz : uint = sn_var.r_data.size() ;
			if( sn_var.is_double() ) { uint_sz >>= 1; };//divide in two if saved as double to get the correct number of elements
			check that uint_sz == mb_var.cols * mb_var.rows;
			if(dbg_flag) {
				out("matlab.is_equal(): comparing data of:\n\t",
					"sn_var with ", uint_sz, " elements and\n\t",
					"mx_arr.name = '", mb_var.name, "' with ", mb_var.rows, " rows and ",
					mb_var.cols, " colomons.");
			};
				//compare each data item in the lists
			check that matlab_is_equal(sn_var, mb_var);
			result = TRUE;
		} else {
			last_rc = ERROR;
			check_result();
		};
	};
		// compares the data in two mx arrays
	is_equal_mx(mx1 : matlab_mx_array_s, mx2 : matlab_mx_array_s) : bool is also {
		result = FALSE;
		try {
				//first check class_id
			check that mx1.its_class == mx2.its_class;
				//check same length 
			check that mx1.cols == mx2.cols ;
			check that mx1.rows == mx2.rows;
			if(dbg_flag) {
				out("matlab.is_equal_mx(): comparing data of:\n\t",
					"mx1.name= '", mx1.name, "' and\n\t",
					"mx2.name = '", mx2.name, "' with ", mx2.rows, " rows and ",
					mx2.cols, " columns." );
			};
				//compare each data item in the lists
			check that matlab_is_equal_mx(mx1, mx2);
			result = TRUE;
		} else {
			last_rc = ERROR;
			check_result();
		};
	};
		//cp the data from a mx array to a sn list
	mx_to_sn(mx : matlab_mx_array_s) : sn_matlab_var_s is also {
		result = new sn_matlab_var_s;
		try {
				//set its class_id
			result.its_class = mx.its_class;
				//set its complexity
			result.is_complex = mx.is_complex; 
				//set its length
			var no_of_uints : uint = mx.cols * mx.rows;
			if( mx.its_class == MB_DOUBLE) { no_of_uints *= 2; }; 
			result.r_data.resize( no_of_uints );
				//resize the imag array if complex
			if( mx.is_complex ) { result.i_data.resize( no_of_uints ); };
			if(dbg_flag) {
				out("matlab.mx_to_sn(): converting mx_arr.name = '", mx.name, "' with \n\t",
					mx.rows, " rows and ", mx.cols, " columns to a sn_var.");
			};
				//call c to copy data
			check that matlab_mx_to_sn_var(mx, result);
		} else {
		};
	};
#ifndef DYNAMIC {
	matlab_init()  : matlab_rc_t is  C routine sn_matlab_init ;
	matlab_fini() : matlab_rc_t is C routine sn_matlab_fini;
	matlab_get_var(v : sn_matlab_var_s) : matlab_rc_t is C routine sn_matlab_get_var;
	matlab_put_var(v : sn_matlab_var_s) : matlab_rc_t is C routine sn_matlab_put_var;
	matlab_is_equal(v : sn_matlab_var_s, mx : matlab_mx_array_s) : bool is C routine sn_matlab_is_equal;
	matlab_is_equal_mx(mx1 : matlab_mx_array_s, mx2 : matlab_mx_array_s) : bool is C routine sn_matlab_is_equal_mx;
	matlab_mx_to_sn_var(mx : matlab_mx_array_s, sn_var : sn_matlab_var_s) : bool is C routine sn_matlab_mx_to_sn_var;
	do_matlab(line : string) : matlab_rc_t is C routine sn_matlab_exec;
} else {
	matlab_init()  : matlab_rc_t is dynamic C routine ./snmb:sn_matlab_init ;
	matlab_fini() : matlab_rc_t is dynamic C routine ./snmb:sn_matlab_fini;
	matlab_get_var(v : sn_matlab_var_s) : matlab_rc_t is dynamic C routine ./snmb:sn_matlab_get_var;
	matlab_put_var(v : sn_matlab_var_s) : matlab_rc_t is dynamic C routine ./snmb:sn_matlab_put_var;
	matlab_is_equal(v : sn_matlab_var_s, mx : matlab_mx_array_s) : bool is dynamic C routine ./snmb:sn_matlab_is_equal;
	matlab_is_equal_mx(mx1 : matlab_mx_array_s, mx2 : matlab_mx_array_s) : bool is dynamic C routine ./snmb:sn_matlab_is_equal_mx;
	matlab_mx_to_sn_var(mx : matlab_mx_array_s, sn_var : sn_matlab_var_s) : bool is dynamic C routine ./snmb:sn_matlab_mx_to_sn_var;
	do_matlab(line : string) : matlab_rc_t is dynamic C routine ./snmb:sn_matlab_exec;
};
		//
	!mx_ptrs : list of matlab_mx_array_s;
	mxc		 : is_complex matlab_mx_array_s;
	mxr		 : FALSE'is_complex matlab_mx_array_s;
	mxcd	 : MB_DOUBLE is_complex matlab_mx_array_s;
	mxrd	 : MB_DOUBLE FALSE'is_complex matlab_mx_array_s;
	init() is also {
		mxc = new is_complex matlab_mx_array_s;
		mxr = new FALSE'is_complex matlab_mx_array_s;
		mxcd = new MB_DOUBLE is_complex matlab_mx_array_s;
		mxrd = new MB_DOUBLE FALSE'is_complex matlab_mx_array_s;
		mx_ptrs.add(mxc);
		mx_ptrs.add(mxr);
		mx_ptrs.add(mxcd);
		mx_ptrs.add(mxrd);
	};
	quit() is also {
		out("quiting matlab");
		do_fini();
	};
	do_fini() is {
		//release memory allocated for mxArray's
		for each (arr) in mx_ptrs {
			arr.free_mx_ptr();
		};
		//close connection
		if is_initialized() {
			last_rc = matlab_fini();
			state = MATLAB_STATE_UNINIT;
			check_result();
		};
	};
-------------------------------------------------------------------------------------
};
extend global {
	!matlab : matlab_ifc_s;
	start_matlab() is {
		if matlab != NULL {
			matlab.do_fini();
			matlab.do_init() ; 
		} else {
			matlab = new matlab_ifc_s;
			matlab.do_init();
		};
	};
	init() is also {
		matlab = NULL;
	};
};
extend sys {
	quit() is also {
		matlab.quit();
	};
};
'>
------------------------
-----  CODE END   ------
------------------------
